const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const permissoes_modulo = sequelize.define(
    'permissoes_modulo',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      modulo: {
        type: DataTypes.TEXT,
      },

      leitura: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      escrita: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      aprovacao: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  permissoes_modulo.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.permissoes_modulo.belongsTo(db.roles, {
      as: 'role',
      foreignKey: {
        name: 'roleId',
      },
      constraints: false,
    });

    db.permissoes_modulo.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.permissoes_modulo.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.permissoes_modulo.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return permissoes_modulo;
};
